diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/test/spectrum-wifi-phy-test.cc ns-3.39/src/wifi/test/spectrum-wifi-phy-test.cc
--- ns-3.38/src/wifi/test/spectrum-wifi-phy-test.cc	2023-03-16 20:54:23.872869300 -0700
+++ ns-3.39/src/wifi/test/spectrum-wifi-phy-test.cc	2023-07-05 14:23:48.125428400 -0700
@@ -15,6 +15,7 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */
 
+#include "ns3/boolean.h"
 #include "ns3/constant-position-mobility-model.h"
 #include "ns3/he-phy.h" //includes OFDM PHY
 #include "ns3/interference-helper.h"
@@ -22,6 +23,7 @@
 #include "ns3/multi-model-spectrum-channel.h"
 #include "ns3/nist-error-rate-model.h"
 #include "ns3/ofdm-ppdu.h"
+#include "ns3/pointer.h"
 #include "ns3/spectrum-wifi-helper.h"
 #include "ns3/spectrum-wifi-phy.h"
 #include "ns3/test.h"
@@ -29,25 +31,80 @@
 #include "ns3/wifi-net-device.h"
 #include "ns3/wifi-phy-listener.h"
 #include "ns3/wifi-psdu.h"
+#include "ns3/wifi-spectrum-phy-interface.h"
 #include "ns3/wifi-spectrum-signal-parameters.h"
 #include "ns3/wifi-spectrum-value-helper.h"
 #include "ns3/wifi-utils.h"
 
+#include <memory>
+#include <tuple>
+#include <vector>
+
 using namespace ns3;
 
-NS_LOG_COMPONENT_DEFINE("SpectrumWifiPhyBasicTest");
+NS_LOG_COMPONENT_DEFINE("SpectrumWifiPhyTest");
 
 static const uint8_t CHANNEL_NUMBER = 36;
-static const uint32_t FREQUENCY = 5180;   // MHz
 static const uint16_t CHANNEL_WIDTH = 20; // MHz
 static const uint16_t GUARD_WIDTH =
     CHANNEL_WIDTH; // MHz (expanded to channel width to model spectrum mask)
 
+/**
+ * Extended SpectrumWifiPhy class for the purpose of the tests.
+ */
 class ExtSpectrumWifiPhy : public SpectrumWifiPhy
 {
   public:
-    using SpectrumWifiPhy::GetBand;
     using SpectrumWifiPhy::SpectrumWifiPhy;
+    using WifiPhy::GetBand;
+
+    /**
+     * Get the spectrum PHY interfaces
+     *
+     * \return the spectrum PHY interfaces
+     */
+    const std::map<FrequencyRange, Ptr<WifiSpectrumPhyInterface>>& GetSpectrumPhyInterfaces() const
+    {
+        return m_spectrumPhyInterfaces;
+    }
+
+    /**
+     * \return the current spectrum PHY interface
+     */
+    Ptr<WifiSpectrumPhyInterface> GetCurrentSpectrumPhyInterface() const
+    {
+        return m_currentSpectrumPhyInterface;
+    }
+
+    /**
+     * Get the info of a given band for a given spectrum PHY interface
+     *
+     * \param bandWidth the width of the band to be returned (MHz)
+     * \param bandIndex the index of the band to be returned
+     * \param freqRange the frequency range identifying the spectrum PHY interface
+     * \param channelWidth the channel width currently used by the spectrum PHY interface
+     *
+     * \return the info that defines the band
+     */
+    WifiSpectrumBandInfo GetBandForInterface(uint16_t bandWidth,
+                                             uint8_t bandIndex,
+                                             const FrequencyRange& freqRange,
+                                             uint16_t channelWidth)
+    {
+        auto subcarrierSpacing = GetSubcarrierSpacing();
+        auto numBandsInChannel = static_cast<size_t>(channelWidth * 1e6 / subcarrierSpacing);
+        auto numBandsInBand = static_cast<size_t>(bandWidth * 1e6 / subcarrierSpacing);
+        auto rxSpectrumModel = m_spectrumPhyInterfaces.at(freqRange)->GetRxSpectrumModel();
+        size_t totalNumBands = rxSpectrumModel->GetNumBands();
+        auto startIndex = ((totalNumBands - numBandsInChannel) / 2) + (bandIndex * numBandsInBand);
+        auto stopIndex = startIndex + numBandsInBand - 1;
+        auto startGuardBand = rxSpectrumModel->Begin();
+        auto startChannel = startGuardBand + startIndex;
+        auto endChannel = startGuardBand + stopIndex + 1;
+        auto lowFreq = static_cast<uint64_t>(startChannel->fc);
+        auto highFreq = static_cast<uint64_t>(endChannel->fc);
+        return {{startIndex, stopIndex}, {lowFreq, highFreq}};
+    }
 };
 
 /**
@@ -75,9 +132,11 @@
     /**
      * Make signal function
      * \param txPowerWatts the transmit power in watts
+     * \param channel the operating channel of the PHY used for the transmission
      * \returns Ptr<SpectrumSignalParameters>
      */
-    Ptr<SpectrumSignalParameters> MakeSignal(double txPowerWatts);
+    Ptr<SpectrumSignalParameters> MakeSignal(double txPowerWatts,
+                                             const WifiPhyOperatingChannel& channel);
     /**
      * Send signal function
      * \param txPowerWatts the transmit power in watts
@@ -121,10 +180,17 @@
 
 // Make a Wi-Fi signal to inject directly to the StartRx() method
 Ptr<SpectrumSignalParameters>
-SpectrumWifiPhyBasicTest::MakeSignal(double txPowerWatts)
+SpectrumWifiPhyBasicTest::MakeSignal(double txPowerWatts, const WifiPhyOperatingChannel& channel)
 {
-    WifiTxVector txVector =
-        WifiTxVector(OfdmPhy::GetOfdmRate6Mbps(), 0, WIFI_PREAMBLE_LONG, 800, 1, 1, 0, 20, false);
+    WifiTxVector txVector = WifiTxVector(OfdmPhy::GetOfdmRate6Mbps(),
+                                         0,
+                                         WIFI_PREAMBLE_LONG,
+                                         800,
+                                         1,
+                                         1,
+                                         0,
+                                         CHANNEL_WIDTH,
+                                         false);
 
     Ptr<Packet> pkt = Create<Packet>(1000);
     WifiMacHeader hdr;
@@ -135,13 +201,13 @@
     Ptr<WifiPsdu> psdu = Create<WifiPsdu>(pkt, hdr);
     Time txDuration = m_phy->CalculateTxDuration(psdu->GetSize(), txVector, m_phy->GetPhyBand());
 
-    Ptr<WifiPpdu> ppdu = Create<OfdmPpdu>(psdu, txVector, FREQUENCY, WIFI_PHY_BAND_5GHZ, m_uid++);
+    Ptr<WifiPpdu> ppdu = Create<OfdmPpdu>(psdu, txVector, channel, m_uid++);
 
-    Ptr<SpectrumValue> txPowerSpectrum =
-        WifiSpectrumValueHelper::CreateOfdmTxPowerSpectralDensity(FREQUENCY,
-                                                                  CHANNEL_WIDTH,
-                                                                  txPowerWatts,
-                                                                  GUARD_WIDTH);
+    Ptr<SpectrumValue> txPowerSpectrum = WifiSpectrumValueHelper::CreateOfdmTxPowerSpectralDensity(
+        channel.GetPrimaryChannelCenterFrequency(CHANNEL_WIDTH),
+        CHANNEL_WIDTH,
+        txPowerWatts,
+        GUARD_WIDTH);
     Ptr<WifiSpectrumSignalParameters> txParams = Create<WifiSpectrumSignalParameters>();
     txParams->psd = txPowerSpectrum;
     txParams->txPhy = nullptr;
@@ -156,7 +222,7 @@
 void
 SpectrumWifiPhyBasicTest::SendSignal(double txPowerWatts)
 {
-    m_phy->StartRx(MakeSignal(txPowerWatts));
+    m_phy->StartRx(MakeSignal(txPowerWatts, m_phy->GetOperatingChannel()), nullptr);
 }
 
 void
@@ -185,17 +251,24 @@
 void
 SpectrumWifiPhyBasicTest::DoSetup()
 {
+    Ptr<MultiModelSpectrumChannel> spectrumChannel = CreateObject<MultiModelSpectrumChannel>();
+    Ptr<Node> node = CreateObject<Node>();
+    Ptr<WifiNetDevice> dev = CreateObject<WifiNetDevice>();
     m_phy = CreateObject<SpectrumWifiPhy>();
-    m_phy->SetOperatingChannel(WifiPhy::ChannelTuple{CHANNEL_NUMBER, 0, WIFI_PHY_BAND_5GHZ, 0});
-    m_phy->ConfigureStandard(WIFI_STANDARD_80211n);
     Ptr<InterferenceHelper> interferenceHelper = CreateObject<InterferenceHelper>();
     m_phy->SetInterferenceHelper(interferenceHelper);
     Ptr<ErrorRateModel> error = CreateObject<NistErrorRateModel>();
     m_phy->SetErrorRateModel(error);
+    m_phy->SetDevice(dev);
+    m_phy->AddChannel(spectrumChannel);
+    m_phy->SetOperatingChannel(WifiPhy::ChannelTuple{CHANNEL_NUMBER, 0, WIFI_PHY_BAND_5GHZ, 0});
+    m_phy->ConfigureStandard(WIFI_STANDARD_80211n);
     m_phy->SetReceiveOkCallback(
         MakeCallback(&SpectrumWifiPhyBasicTest::SpectrumWifiPhyRxSuccess, this));
     m_phy->SetReceiveErrorCallback(
         MakeCallback(&SpectrumWifiPhyBasicTest::SpectrumWifiPhyRxFailure, this));
+    dev->SetPhy(m_phy);
+    node->AddDevice(dev);
 }
 
 void
@@ -241,19 +314,9 @@
   public:
     /**
      * Create a test PhyListener
-     *
      */
-    TestPhyListener()
-        : m_notifyRxStart(0),
-          m_notifyRxEndOk(0),
-          m_notifyRxEndError(0),
-          m_notifyMaybeCcaBusyStart(0)
-    {
-    }
-
-    ~TestPhyListener() override
-    {
-    }
+    TestPhyListener() = default;
+    ~TestPhyListener() override = default;
 
     void NotifyRxStart(Time duration) override
     {
@@ -283,7 +346,15 @@
                             const std::vector<Time>& /*per20MhzDurations*/) override
     {
         NS_LOG_FUNCTION(this << duration << channelType);
-        ++m_notifyMaybeCcaBusyStart;
+        if (duration.IsStrictlyPositive())
+        {
+            ++m_notifyMaybeCcaBusyStart;
+            if (!m_ccaBusyStart.IsStrictlyPositive())
+            {
+                m_ccaBusyStart = Simulator::Now();
+            }
+            m_ccaBusyEnd = std::max(m_ccaBusyEnd, Simulator::Now() + duration);
+        }
     }
 
     void NotifySwitchingStart(Time duration) override
@@ -306,10 +377,26 @@
     {
     }
 
-    uint32_t m_notifyRxStart;           ///< notify receive start
-    uint32_t m_notifyRxEndOk;           ///< notify receive end OK
-    uint32_t m_notifyRxEndError;        ///< notify receive end error
-    uint32_t m_notifyMaybeCcaBusyStart; ///< notify maybe CCA busy start
+    /**
+     * Reset function
+     */
+    void Reset()
+    {
+        NS_LOG_FUNCTION(this);
+        m_notifyRxStart = 0;
+        m_notifyRxEndOk = 0;
+        m_notifyRxEndError = 0;
+        m_notifyMaybeCcaBusyStart = 0;
+        m_ccaBusyStart = Seconds(0);
+        m_ccaBusyEnd = Seconds(0);
+    }
+
+    uint32_t m_notifyRxStart{0};           ///< notify receive start
+    uint32_t m_notifyRxEndOk{0};           ///< notify receive end OK
+    uint32_t m_notifyRxEndError{0};        ///< notify receive end error
+    uint32_t m_notifyMaybeCcaBusyStart{0}; ///< notify maybe CCA busy start
+    Time m_ccaBusyStart{0};                ///< CCA_BUSY start time
+    Time m_ccaBusyEnd{0};                  ///< CCA_BUSY end time
 };
 
 /**
@@ -413,7 +500,7 @@
     uint16_t m_txChannelWidth; ///< TX channel width (MHz)
     uint16_t m_rxChannelWidth; ///< RX channel width (MHz)
 
-    std::set<WifiSpectrumBand> m_ruBands; ///< spectrum bands associated to all the RUs
+    std::set<WifiSpectrumBandIndices> m_ruBands; ///< spectrum bands associated to all the RUs
 };
 
 SpectrumWifiPhyFilterTest::SpectrumWifiPhyFilterTest()
@@ -462,8 +549,8 @@
 {
     for (const auto& pair : rxPowersW)
     {
-        NS_LOG_INFO("band: (" << pair.first.first << ";" << pair.first.second << ") -> powerW="
-                              << pair.second << " (" << WToDbm(pair.second) << " dBm)");
+        NS_LOG_INFO("band: (" << pair.first << ") -> powerW=" << pair.second << " ("
+                              << WToDbm(pair.second) << " dBm)");
     }
 
     size_t numBands = rxPowersW.size();
@@ -478,7 +565,7 @@
                           "Total number of bands handled by the receiver is incorrect");
 
     uint16_t channelWidth = std::min(m_txChannelWidth, m_rxChannelWidth);
-    WifiSpectrumBand band = m_rxPhy->GetBand(channelWidth, 0);
+    auto band = m_rxPhy->GetBand(channelWidth, 0);
     auto it = rxPowersW.find(band);
     NS_LOG_INFO("powerW total band: " << it->second << " (" << WToDbm(it->second) << " dBm)");
     int totalRxPower = static_cast<int>(WToDbm(it->second) + 0.5);
@@ -516,8 +603,8 @@
 void
 SpectrumWifiPhyFilterTest::DoSetup()
 {
-    // WifiHelper::EnableLogComponents ();
-    // LogComponentEnable ("SpectrumWifiPhyBasicTest", LOG_LEVEL_ALL);
+    // WifiHelper::EnableLogComponents();
+    // LogComponentEnable("SpectrumWifiPhyTest", LOG_LEVEL_ALL);
 
     Ptr<MultiModelSpectrumChannel> spectrumChannel = CreateObject<MultiModelSpectrumChannel>();
     Ptr<FriisPropagationLossModel> lossModel = CreateObject<FriisPropagationLossModel>();
@@ -530,14 +617,13 @@
     Ptr<Node> txNode = CreateObject<Node>();
     Ptr<WifiNetDevice> txDev = CreateObject<WifiNetDevice>();
     m_txPhy = CreateObject<ExtSpectrumWifiPhy>();
-    m_txPhy->CreateWifiSpectrumPhyInterface(txDev);
-    m_txPhy->ConfigureStandard(WIFI_STANDARD_80211ax);
     Ptr<InterferenceHelper> txInterferenceHelper = CreateObject<InterferenceHelper>();
     m_txPhy->SetInterferenceHelper(txInterferenceHelper);
     Ptr<ErrorRateModel> txErrorModel = CreateObject<NistErrorRateModel>();
     m_txPhy->SetErrorRateModel(txErrorModel);
     m_txPhy->SetDevice(txDev);
-    m_txPhy->SetChannel(spectrumChannel);
+    m_txPhy->AddChannel(spectrumChannel);
+    m_txPhy->ConfigureStandard(WIFI_STANDARD_80211ax);
     Ptr<ConstantPositionMobilityModel> apMobility = CreateObject<ConstantPositionMobilityModel>();
     m_txPhy->SetMobility(apMobility);
     txDev->SetPhy(m_txPhy);
@@ -547,13 +633,12 @@
     Ptr<Node> rxNode = CreateObject<Node>();
     Ptr<WifiNetDevice> rxDev = CreateObject<WifiNetDevice>();
     m_rxPhy = CreateObject<ExtSpectrumWifiPhy>();
-    m_rxPhy->CreateWifiSpectrumPhyInterface(rxDev);
-    m_rxPhy->ConfigureStandard(WIFI_STANDARD_80211ax);
     Ptr<InterferenceHelper> rxInterferenceHelper = CreateObject<InterferenceHelper>();
     m_rxPhy->SetInterferenceHelper(rxInterferenceHelper);
     Ptr<ErrorRateModel> rxErrorModel = CreateObject<NistErrorRateModel>();
     m_rxPhy->SetErrorRateModel(rxErrorModel);
-    m_rxPhy->SetChannel(spectrumChannel);
+    m_rxPhy->AddChannel(spectrumChannel);
+    m_rxPhy->ConfigureStandard(WIFI_STANDARD_80211ax);
     Ptr<ConstantPositionMobilityModel> sta1Mobility = CreateObject<ConstantPositionMobilityModel>();
     m_rxPhy->SetMobility(sta1Mobility);
     rxDev->SetPhy(m_rxPhy);
@@ -635,14 +720,17 @@
                 HeRu::RuType ruType = static_cast<HeRu::RuType>(type);
                 for (std::size_t index = 1; index <= HeRu::GetNRus(bw, ruType); index++)
                 {
-                    HeRu::SubcarrierGroup group = HeRu::GetSubcarrierGroup(bw, ruType, index);
-                    HeRu::SubcarrierRange range =
-                        std::make_pair(group.front().first, group.back().second);
-                    WifiSpectrumBand band = m_rxPhy->ConvertHeRuSubcarriers(
-                        bw,
-                        m_rxPhy->GetGuardBandwidth(m_rxChannelWidth),
-                        range,
-                        i);
+                    HeRu::SubcarrierGroup subcarrierGroup =
+                        HeRu::GetSubcarrierGroup(bw, ruType, index);
+                    HeRu::SubcarrierRange subcarrierRange =
+                        std::make_pair(subcarrierGroup.front().first,
+                                       subcarrierGroup.back().second);
+                    const auto band =
+                        HePhy::ConvertHeRuSubcarriers(bw,
+                                                      m_rxPhy->GetGuardBandwidth(m_rxChannelWidth),
+                                                      m_rxPhy->GetSubcarrierSpacing(),
+                                                      subcarrierRange,
+                                                      i);
                     m_ruBands.insert(band);
                 }
             }
